package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.alibaba.csp.sentinel.util.StringUtil;
import com.lzmispt.core.entity.dto.querymodel.QueryModelDTO;
import com.lzmispt.core.entity.dto.querymodel.SortModelDTO;
import com.lzmispt.core.service.query.IQuery;
import com.lzmispt.data.center.entity.dto.log.CommonLogDTO;
import com.lzmispt.data.center.entity.dto.querymodel.DCQueryModelDTO;
import com.lzmispt.data.center.entity.dto.resource.apply.GetUseRelationInterfaceInfoVO;
import com.lzmispt.data.center.entity.dto.resource.metadata.DeleteEntityRelationMsg;
import com.lzmispt.data.center.entity.dto.resource.metadata.GetDataRangeUsageDTO;
import com.lzmispt.data.center.entity.enums.MetadataEntityRelationsTypeEnum;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.metadata.DataRangeUsageVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.EntityChildRelationsItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityRelationsVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.DataItemUsedVO;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.client.DataInterfaceClient;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.dao.collectiontool.ICollectionToolDao;
import com.lzmispt.data.resource.dao.file.IFileInfoTableDao;
import com.lzmispt.data.resource.dao.metadata.IMetadataDao;
import com.lzmispt.data.resource.entity.dto.metadata.EditEntityRelationsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.GetDataItemUsageDTO;
import com.lzmispt.data.resource.entity.dto.metadata.GetRelationsDataDTO;
import com.lzmispt.data.resource.entity.dto.metadata.MetaEntityRelationsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.UpdateEntityRelationsDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.po.metadata.DataRangeUsagePO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataDataItemUsagePO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataDirectoryPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityRelationsPO;
import com.lzmispt.data.resource.entity.vo.metadata.EntityRelationsItemVO;
import com.lzmispt.data.resource.entity.vo.metadata.MetaEntityRelationsVO;
import com.lzmispt.data.resource.entity.vo.metadata.MetadataDataItemUsageVO;
import com.lzmispt.data.resource.entity.vo.metadata.MetadataElementView;
import com.lzmispt.data.resource.entity.vo.metadata.MetadataEntityRelationsView;
import com.lzmispt.data.resource.entity.vo.metadata.MetadataEntityView;
import com.lzmispt.data.resource.entity.vo.metadata.MetadataEntityViewVO;
import com.lzmispt.data.resource.entity.vo.metadata.UseEntityRelationInfoVO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.metadata.IEntityRelation;
import com.lzmispt.data.resource.service.metadata.IResAndDataEntityRelation;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.database.IManage;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.util.HeaderInterceptor;
import com.lzmispt.framework.entity.entity.ResultEntity;
import com.lzmispt.framework.exception.ExceptionUtil;
import com.lzmispt.framework.fconst.FrameConst;
import com.lzmispt.framework.log.LogHelper;
import com.lzmispt.framework.utils.RabbitMQUtil;
import com.lzmispt.framework.utils.WorkerId;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.util.CollectionUtils;

@RefreshScope
public abstract class EntityRelationManager implements IEntityRelation, IManage {
  private static final String LOG_TIP_MODIFY = "】修改为【";
  
  @Autowired
  private IQuery query;
  
  @Autowired
  DataInterfaceClient dataInterfaceClient;
  
  @Value("${data-center.data-mode:mysql}")
  private String dbType;
  
  @Autowired
  DataApplyClient dataApplyClient;
  
  @Autowired
  DataStandardClient dataStandardClient;
  
  @Autowired
  IResAndDataEntityRelation iResAndDataEntityRelation;
  
  public ResultEntity<List> getRelationsMapByDirectoryId(Long directoryId, Integer dataResourceCategory, String platCode, String tokenId) {
    List<MetadataEntityView> metadataEntityViews = new ArrayList<>();
    Map<Long, MetadataEntityPO> metadataEntityDicMap = new HashMap<>();
    ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(directoryId, dataResourceCategory, platCode, tokenId);
    for (MetadataEntityPO item : Collections.<ResAndDataEntityDTO>singletonList(resAndDataEntityDTO)) {
      List<MetaEntityRelationsVO> childRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getChildRelationsByEntityId(item.getEntityId(), dataResourceCategory, platCode).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
      if (childRelations.size() > 0) {
        if (!metadataEntityDicMap.containsKey(item.getEntityId())) {
          metadataEntityDicMap.put(item.getEntityId(), item);
          MetadataEntityView entityView = getMetadataEntityView(item, dataResourceCategory, platCode, tokenId);
          entityView.setIsCurrentDirectory(true);
          metadataEntityViews.add(entityView);
        } 
        for (MetaEntityRelationsVO relation : childRelations) {
          if (relation == null || relation.getFkEntityId() == null || relation
            .getPkEntityId() == null || relation.getFkInfoItemId() == null || relation
            .getPkInfoItemId() == null || relation.getRelationId() == null)
            continue; 
          if (!metadataEntityDicMap.containsKey(relation.getFkEntityId())) {
            ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(relation.getFkEntityId(), dataResourceCategory, platCode, tokenId);
            metadataEntityDicMap.put(relation.getFkEntityId(), resAndDataEntityDTO1);
            metadataEntityViews.add(getMetadataEntityView((MetadataEntityPO)resAndDataEntityDTO1, dataResourceCategory, platCode, tokenId));
          } 
        } 
      } 
      List<MetaEntityRelationsVO> parentRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getParentRelationsByEntityId(item.getEntityId(), dataResourceCategory, platCode).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
      if (parentRelations.size() > 0) {
        if (!metadataEntityDicMap.containsKey(item.getEntityId())) {
          metadataEntityDicMap.put(item.getEntityId(), item);
          MetadataEntityView entityView = getMetadataEntityView(item, dataResourceCategory, platCode, tokenId);
          entityView.setIsCurrentDirectory(true);
          metadataEntityViews.add(entityView);
        } 
        for (MetaEntityRelationsVO relation : parentRelations) {
          if (relation == null || relation.getFkEntityId() == null || relation
            .getPkEntityId() == null || relation.getFkInfoItemId() == null || relation
            .getPkInfoItemId() == null || relation.getRelationId() == null)
            continue; 
          if (!metadataEntityDicMap.containsKey(relation.getFkEntityId())) {
            ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(relation.getFkEntityId(), dataResourceCategory, platCode, tokenId);
            metadataEntityDicMap.put(relation.getFkEntityId(), resAndDataEntityDTO1);
            metadataEntityViews.add(getMetadataEntityView((MetadataEntityPO)resAndDataEntityDTO1, dataResourceCategory, platCode, tokenId));
          } 
          if (!metadataEntityDicMap.containsKey(relation.getPkEntityId())) {
            ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(relation.getPkEntityId(), dataResourceCategory, platCode, tokenId);
            metadataEntityDicMap.put(relation.getPkEntityId(), resAndDataEntityDTO1);
            metadataEntityViews.add(getMetadataEntityView((MetadataEntityPO)resAndDataEntityDTO1, dataResourceCategory, platCode, tokenId));
          } 
        } 
      } 
    } 
    return ResultEntity.successMessage(metadataEntityViews);
  }
  
  public ResultEntity<Boolean> editEntityRelations(EditEntityRelationsDTO editEntityRelationsDTO, boolean isAdd) {
    List<EditEntityRelationsDTO.RelationsItemInfo> editRelationsItemInfoList = editEntityRelationsDTO.getRelationsItemInfoList();
    if (CollectionUtils.isEmpty(editRelationsItemInfoList))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_CHILD_ENTITY_IDS_NO_EMPTY.getCode()), StatusCodeEnum.DATA_RESOURCE_CHILD_ENTITY_IDS_NO_EMPTY.getMessage(), Boolean.valueOf(false)); 
    for (EditEntityRelationsDTO.RelationsItemInfo item : editRelationsItemInfoList) {
      if (editEntityRelationsDTO.getFkEntityId() == null || item.getPkInfoItemId() == null || item.getFkInfoItemId() == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ENTITY_RELATIONS_INCOMPLETE.getCode()), StatusCodeEnum.DATA_RESOURCE_ENTITY_RELATIONS_INCOMPLETE.getMessage(), Boolean.valueOf(false)); 
    } 
    ResAndDataEntityDTO resAndDataEntityDTO = null;
    if (editEntityRelationsDTO.getPkEntityId() == null) {
      resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(editEntityRelationsDTO.getDirectoryId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    } else {
      resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(editEntityRelationsDTO.getPkEntityId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    } 
    if (resAndDataEntityDTO == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DIRECTORY_NOT_EXIST_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_DIRECTORY_NOT_EXIST_ENTITY.getMessage(), Boolean.valueOf(false)); 
    Long pkEntityId = resAndDataEntityDTO.getEntityId();
    if (pkEntityId.equals(editEntityRelationsDTO.getFkEntityId()))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ADD_RELATIONS_ENTITY_ID_EQUAL_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_ADD_RELATIONS_ENTITY_ID_EQUAL_FAILED.getMessage(), Boolean.valueOf(false)); 
    List<MetadataEntityInfoItemPO> metadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(pkEntityId, editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    if (CollectionUtils.isEmpty(metadataEntityInfoItems) || metadataEntityInfoItems.stream().noneMatch(item -> (item.getInfoItemParentId() == null))) {
      StatusCodeEnum codeEnum = getDefaultCode().equals("Manage") ? StatusCodeEnum.DATA_RESOURCE_MAIN_TABLE_NO_SETTING_INFO_ITEM : StatusCodeEnum.DATA_RESOURCE_MAIN_TABLE_NO_SETTING_FIELD;
      return ResultEntity.errorMessage(Integer.valueOf(codeEnum.getCode()), codeEnum.getMessage(), Boolean.valueOf(false));
    } 
    ResAndDataDirectoryDTO resAndDataDirectoryDTO = MetadataManager.selectDirectoryByDirectoryId(resAndDataEntityDTO.getDirectoryId(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getDataResourceCategory());
    ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(editEntityRelationsDTO.getFkEntityId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    if (resAndDataEntityDTO1 == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_CHILD_ENTITY_NO_EXISTS.getCode()), "子实体【" + editEntityRelationsDTO.getFkEntityId() + "】不存在或者已经删除", Boolean.valueOf(false)); 
    List<MetaEntityRelationsVO> relationsList = this.iResAndDataEntityRelation.getRelationReferenceChain(pkEntityId, editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode());
    if (relationsList.stream().anyMatch(r -> r.getPkEntityId().equals(editEntityRelationsDTO.getFkEntityId())))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_MAIN_TABLE_CIRCULAR_REFERENCE.getCode()), "主表和【" + resAndDataEntityDTO1.getEntityName() + "】间存在循环引用", Boolean.valueOf(false)); 
    String relationName = StringUtil.isEmpty(editEntityRelationsDTO.getRelationName()) ? "未命名" : editEntityRelationsDTO.getRelationName();
    List<MetaEntityRelationsVO> allRelationsList = this.iResAndDataEntityRelation.getAllRelationsByPkAndFkEntityId(pkEntityId, editEntityRelationsDTO.getFkEntityId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode());
    Date createTime = (isAdd || CollectionUtils.isEmpty(allRelationsList)) ? new Date() : ((MetaEntityRelationsVO)allRelationsList.get(0)).getCreateTime();
    List<MetaEntityRelationsVO> deleteRelations = checkAndDeleteRelationsForEdit(relationName, editRelationsItemInfoList, allRelationsList, editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode());
    List<MetaEntityRelationsDTO> addedRelations = new ArrayList<>();
    for (EditEntityRelationsDTO.RelationsItemInfo item : editRelationsItemInfoList) {
      if (addedRelations.stream().anyMatch(r -> (r.getPkInfoItemId().equals(item.getPkInfoItemId()) && r.getFkInfoItemId().equals(item.getFkInfoItemId()))))
        continue; 
      MetaEntityRelationsDTO relation = new MetaEntityRelationsDTO();
      relation.setRelationId((Long)WorkerId.getNextId(Long.class));
      relation.setPkEntityId(pkEntityId);
      relation.setFkEntityId(editEntityRelationsDTO.getFkEntityId());
      relation.setRelationType(Integer.valueOf(MetadataEntityRelationsTypeEnum.Reference.getTypeCode()));
      relation.setRelationName(relationName);
      relation.setPkInfoItemId(item.getPkInfoItemId());
      relation.setFkInfoItemId(item.getFkInfoItemId());
      relation.setUserId(editEntityRelationsDTO.getUserId());
      relation.setOrganizationId(editEntityRelationsDTO.getOrganizationId());
      relation.setCreateTime(createTime);
      relation.setUpdateTime(new Date());
      relation.setIsDelete(DCConst.FALSE);
      int addCount = this.iResAndDataEntityRelation.addMetadataEntityRelations(relation, editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode());
      if (addCount == 0)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ADD_SUB_TABLE_REFERENCE_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_ADD_SUB_TABLE_REFERENCE_FAILED
            .getMessage(), Boolean.valueOf(false)); 
      addedRelations.add(relation);
    } 
    recordAddEntityRelationsLog(isAdd, (MetadataDirectoryPO)resAndDataDirectoryDTO, relationName, (MetadataEntityPO)resAndDataEntityDTO, (MetadataEntityPO)resAndDataEntityDTO1, editEntityRelationsDTO, addedRelations, deleteRelations);
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  private List<MetaEntityRelationsVO> checkAndDeleteRelationsForEdit(String relationName, List<EditEntityRelationsDTO.RelationsItemInfo> editRelationsItemInfoList, List<MetaEntityRelationsVO> allRelationsList, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> deleteRelations = new ArrayList<>();
    for (MetaEntityRelationsVO item : allRelationsList) {
      boolean haveRelation = false;
      for (int i = editRelationsItemInfoList.size() - 1; i >= 0; i--) {
        if (((EditEntityRelationsDTO.RelationsItemInfo)editRelationsItemInfoList.get(i)).getPkInfoItemId().equals(item.getPkInfoItemId()) && ((EditEntityRelationsDTO.RelationsItemInfo)editRelationsItemInfoList
          .get(i)).getFkInfoItemId().equals(item.getFkInfoItemId())) {
          if (!relationName.equals(item.getRelationName())) {
            MetaEntityRelationsDTO updateRelation = new MetaEntityRelationsDTO();
            BeanUtils.copyProperties(item, updateRelation);
            updateRelation.setRelationName(relationName);
            updateRelation.setUpdateTime(new Date());
            this.iResAndDataEntityRelation.updateMetadataEntityRelations(updateRelation, dataResourceCategory, platCode);
          } 
          editRelationsItemInfoList.remove(i);
          haveRelation = true;
          break;
        } 
      } 
      if (!haveRelation) {
        item.setIsDelete(DCConst.TRUE);
        MetaEntityRelationsDTO updateRelation = new MetaEntityRelationsDTO();
        BeanUtils.copyProperties(item, updateRelation);
        this.iResAndDataEntityRelation.updateMetadataEntityRelations(updateRelation, dataResourceCategory, getDefaultCode());
        deleteRelations.add(item);
      } 
    } 
    return deleteRelations;
  }
  
  private void recordAddEntityRelationsLog(boolean isAdd, MetadataDirectoryPO metadataDirectory, String relationName, MetadataEntityPO metadataEntityPO, MetadataEntityPO fkEntity, EditEntityRelationsDTO editEntityRelationsDTO, List<MetaEntityRelationsDTO> addedRelations, List<MetaEntityRelationsVO> deleteRelations) {
    StringBuilder logInfo = new StringBuilder();
    if (logInfo.length() == 0) {
      logInfo.append(isAdd ? "新增" : "修改");
      logInfo.append("Standard".equals(getDefaultCode()) ? "数据关系 为数据资源【" : "数据关系 为数据表【");
      logInfo.append(metadataDirectory.getDirectoryName()).append("】")
        .append(",关系名【").append(relationName).append("】")
        .append(",主表名称【").append(metadataEntityPO.getEntityName()).append("】")
        .append(",子表名称【").append(fkEntity.getEntityName()).append("】; ");
    } 
    List<MetadataEntityInfoItemPO> pkMetadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(metadataEntityPO.getEntityId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    List<MetadataEntityInfoItemPO> fkMetadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(editEntityRelationsDTO.getFkEntityId(), editEntityRelationsDTO.getDataResourceCategory(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId());
    if (!CollectionUtils.isEmpty(pkMetadataEntityInfoItems) && !CollectionUtils.isEmpty(fkMetadataEntityInfoItems)) {
      if (!CollectionUtils.isEmpty(addedRelations)) {
        logInfo.append("新增了字段对应关系:");
        for (MetaEntityRelationsDTO item : addedRelations) {
          MetadataEntityInfoItemPO pkInfoItemPO = pkMetadataEntityInfoItems.stream().filter(p -> p.getInfoItemId().equals(item.getPkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
          MetadataEntityInfoItemPO fkInfoItemPO = fkMetadataEntityInfoItems.stream().filter(f -> f.getInfoItemId().equals(item.getFkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
          logInfo.append("【").append(pkInfoItemPO.getInfoItemName()).append("】")
            .append("<==>")
            .append("【").append(fkInfoItemPO.getInfoItemName()).append("】 ");
        } 
      } 
      if (!CollectionUtils.isEmpty(deleteRelations)) {
        logInfo.append(CollectionUtils.isEmpty(addedRelations) ? "" : "; ");
        logInfo.append("删除了字段对应关系:");
        for (MetaEntityRelationsVO item : deleteRelations) {
          MetadataEntityInfoItemPO pkInfoItemPO = pkMetadataEntityInfoItems.stream().filter(p -> p.getInfoItemId().equals(item.getPkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
          MetadataEntityInfoItemPO fkInfoItemPO = fkMetadataEntityInfoItems.stream().filter(f -> f.getInfoItemId().equals(item.getFkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
          logInfo.append("【").append(pkInfoItemPO.getInfoItemName()).append("】")
            .append("<==>")
            .append("【").append(fkInfoItemPO.getInfoItemName()).append("】  ");
        } 
      } 
    } 
    if (logInfo.length() > 0)
      logSystemInfo(logInfo.toString(), editEntityRelationsDTO.getPlatCode(), editEntityRelationsDTO.getTokenId()); 
  }
  
  public ResultEntity<Map> getRelationListByDirectoryId(GetRelationsDataDTO getRelationsDataDTO) {
    IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class);
    List<MetadataEntityPO> metadataEntityList = metadataDao.selectMetadataEntityByDirectoryId(getRelationsDataDTO.getDirectoryId());
    List<EntityRelationsItemVO> itemList = new ArrayList<>();
    Map<String, Object> resultMap = new HashMap<>();
    Map<Long, MetadataEntityInfoItemPO> infoItemMap = new HashMap<>();
    Map<Long, MetadataEntityPO> entityMap = new HashMap<>();
    metadataEntityList.forEach(item -> (MetadataEntityPO)entityMap.put(item.getEntityId(), item));
    DCQueryModelDTO queryModel = getRelationsDataDTO.getQuery();
    for (MetadataEntityPO entity : metadataEntityList) {
      List<MetaEntityRelationsVO> allRelations;
      if (metadataEntityList.size() == 1 && queryModel != null && queryModel.getPageSize() != null) {
        Map<String, Object> param = new HashMap<>();
        List<SortModelDTO> sortModels = queryModel.getSortModels();
        if (sortModels != null)
          for (SortModelDTO sortModel : sortModels) {
            switch (sortModel.getFieldName()) {
              case "pkEntityName":
                param.put("needJoinPkEntity", Boolean.valueOf(true));
              case "pkInfoItemName":
                param.put("needJoinPkInfoItem", Boolean.valueOf(true));
              case "fkEntityName":
                param.put("needJoinFkEntity", Boolean.valueOf(true));
              case "fkInfoItemName":
                param.put("needJoinFkInfoItem", Boolean.valueOf(true));
            } 
          }  
        boolean isEscapeStr = false;
        if (this.dbType.equalsIgnoreCase("sqlserver"))
          isEscapeStr = true; 
        String whereSql = (String)this.query.getWhereSqlStr((QueryModelDTO)queryModel, this.dbType, true, isEscapeStr).getObj();
        if (!StringUtil.isEmpty(whereSql) && queryModel.getFilterModel() != null)
          whereSql = " and " + whereSql; 
        param.put("query", whereSql);
        param.put("entityId", entity.getEntityId());
        param.put("onlyChild", Boolean.valueOf(false));
        allRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getRelationsByEntityId(param, getRelationsDataDTO.getDataResourceCategory(), getDefaultCode()).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
        int total = this.iResAndDataEntityRelation.getRelationsCountByEntityId(entity.getEntityId(), getRelationsDataDTO.getDataResourceCategory(), getDefaultCode()).intValue();
        resultMap.put("total", Integer.valueOf(total));
      } else {
        Map<String, Object> param = new HashMap<>();
        param.put("entityId", entity.getEntityId());
        param.put("onlyChild", Boolean.valueOf(false));
        allRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getRelationsByEntityId(param, getRelationsDataDTO.getDataResourceCategory(), getDefaultCode()).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
      } 
      for (MetaEntityRelationsVO relation : allRelations) {
        MetadataEntityInfoItemPO pkItem = getInfoItemFromCache(getRelationsDataDTO.getTokenId(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getDataResourceCategory(), infoItemMap, relation.getPkInfoItemId());
        MetadataEntityInfoItemPO fkItem = getInfoItemFromCache(getRelationsDataDTO.getTokenId(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getDataResourceCategory(), infoItemMap, relation.getFkInfoItemId());
        EntityRelationsItemVO entityRelationsItem = new EntityRelationsItemVO();
        entityRelationsItem.setRelationId(relation.getRelationId());
        entityRelationsItem.setRelationName(relation.getRelationName());
        entityRelationsItem.setPkEntityId(relation.getPkEntityId());
        MetadataEntityPO pkEntity = getEntityFromCache(entityMap, relation.getPkEntityId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getTokenId());
        entityRelationsItem.setPkEntityName(pkEntity.getEntityName());
        entityRelationsItem.setPkInfoItemId((pkItem == null) ? null : relation.getPkInfoItemId());
        entityRelationsItem.setPkInfoItemName((pkItem == null) ? "" : pkItem.getInfoItemName());
        MetadataEntityPO fkEntity = getEntityFromCache(entityMap, relation.getFkEntityId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getTokenId());
        entityRelationsItem.setFkEntityId(relation.getFkEntityId());
        entityRelationsItem.setFkEntityName((fkEntity == null) ? "" : fkEntity.getEntityName());
        entityRelationsItem.setFkInfoItemId((fkItem == null) ? null : relation.getFkInfoItemId());
        entityRelationsItem.setFkInfoItemName((fkItem == null) ? "" : fkItem.getInfoItemName());
        itemList.add(entityRelationsItem);
      } 
    } 
    resultMap.put("list", itemList);
    return ResultEntity.successMessage(resultMap);
  }
  
  public ResultEntity<Map> getRelationGroupListByDirectoryId(GetRelationsDataDTO getRelationsDataDTO) {
    ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(getRelationsDataDTO.getDirectoryId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getTokenId());
    List<EntityRelationsItemVO> itemList = new ArrayList<>();
    Map<String, Object> resultMap = new HashMap<>();
    Map<Long, MetadataEntityPO> entityMap = new HashMap<>();
    DCQueryModelDTO queryModel = getRelationsDataDTO.getQuery();
    for (SortModelDTO item : queryModel.getSortModels()) {
      if (!item.getFieldName().equalsIgnoreCase("pkEntityName") && 
        !item.getFieldName().equalsIgnoreCase("fkEntityName") && 
        !item.getFieldName().equalsIgnoreCase("relationname")) {
        queryModel.getSortModels().remove(item);
        break;
      } 
    } 
    for (MetadataEntityPO entity : Collections.<ResAndDataEntityDTO>singletonList(resAndDataEntityDTO)) {
      List<MetaEntityRelationsVO> allRelations;
      if (queryModel != null && queryModel.getPageSize() != null) {
        Map<String, Object> param = new HashMap<>();
        List<SortModelDTO> sortModels = queryModel.getSortModels();
        if (sortModels != null)
          for (SortModelDTO sortModel : sortModels) {
            switch (sortModel.getFieldName()) {
              case "pkEntityName":
                param.put("needJoinPkEntity", Boolean.valueOf(true));
              case "fkEntityName":
                param.put("needJoinFkEntity", Boolean.valueOf(true));
            } 
          }  
        boolean isEscapeStr = false;
        if (this.dbType.equalsIgnoreCase("sqlserver"))
          isEscapeStr = true; 
        String whereSql = (String)this.query.getWhereSqlStr((QueryModelDTO)queryModel, this.dbType, true, isEscapeStr).getObj();
        if (!StringUtil.isEmpty(whereSql) && queryModel.getFilterModel() != null)
          whereSql = " and " + whereSql; 
        param.put("query", whereSql);
        param.put("entityId", entity.getEntityId());
        param.put("onlyChild", Boolean.valueOf(false));
        allRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getRelationGroupListByEntityId(param, getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode()).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
        int total = this.iResAndDataEntityRelation.getRelationGroupCountByEntityId(entity.getEntityId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode());
        resultMap.put("total", Integer.valueOf(total));
      } else {
        Map<String, Object> param = new HashMap<>();
        param.put("entityId", entity.getEntityId());
        param.put("onlyChild", Boolean.valueOf(false));
        allRelations = (List<MetaEntityRelationsVO>)this.iResAndDataEntityRelation.getRelationsByEntityId(param, getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode()).stream().filter(m -> (m.getRelationType().intValue() == MetadataEntityRelationsTypeEnum.Reference.getTypeCode())).collect(Collectors.toList());
      } 
      for (MetaEntityRelationsVO relation : allRelations) {
        EntityRelationsItemVO entityRelationsItem = new EntityRelationsItemVO();
        entityRelationsItem.setRelationName(relation.getRelationName());
        entityRelationsItem.setPkEntityId(relation.getPkEntityId());
        MetadataEntityPO pkEntity = getEntityFromCache(entityMap, relation.getPkEntityId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getTokenId());
        entityRelationsItem.setPkEntityName(pkEntity.getEntityName());
        MetadataEntityPO fkEntity = getEntityFromCache(entityMap, relation.getFkEntityId(), getRelationsDataDTO.getDataResourceCategory(), getRelationsDataDTO.getPlatCode(), getRelationsDataDTO.getTokenId());
        entityRelationsItem.setFkEntityId(relation.getFkEntityId());
        entityRelationsItem.setFkEntityName((fkEntity == null) ? "" : fkEntity.getEntityName());
        itemList.add(entityRelationsItem);
      } 
    } 
    resultMap.put("list", itemList);
    return ResultEntity.successMessage(resultMap);
  }
  
  public ResultEntity<Map> getEntityRelationGroupInfo(Long pkEntityId, Long fkEntityId, Integer dataResourceCategory, String tokenId, String platCode) {
    Map<String, Object> resultMap = new HashMap<>();
    if (pkEntityId == null || fkEntityId == null)
      return ResultEntity.successMessage(resultMap); 
    ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(pkEntityId, dataResourceCategory, platCode, tokenId);
    resultMap.put("pkEntityId", pkEntityId);
    resultMap.put("pkEntityName", (resAndDataEntityDTO1 != null) ? resAndDataEntityDTO1.getEntityName() : null);
    ResAndDataEntityDTO resAndDataEntityDTO2 = MetadataManager.selectEntityByEntityId(fkEntityId, dataResourceCategory, platCode, tokenId);
    resultMap.put("fkEntityId", fkEntityId);
    resultMap.put("fkEntityName", (resAndDataEntityDTO2 != null) ? resAndDataEntityDTO2.getEntityName() : null);
    List<EntityRelationsItemVO> itemList = new ArrayList<>();
    List<MetaEntityRelationsVO> allRelations = this.iResAndDataEntityRelation.getAllRelationsByPkAndFkEntityId(pkEntityId, fkEntityId, dataResourceCategory, platCode);
    if (!CollectionUtils.isEmpty(allRelations)) {
      resultMap.put("relationName", ((MetaEntityRelationsVO)allRelations.get(0)).getRelationName());
      EntityRelationsItemVO entityRelationsItem = null;
      List<MetadataEntityInfoItemPO> pkMetadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(pkEntityId, dataResourceCategory, platCode, tokenId);
      List<MetadataEntityInfoItemPO> fkMetadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(fkEntityId, dataResourceCategory, platCode, tokenId);
      for (MetaEntityRelationsVO relation : allRelations) {
        MetadataEntityInfoItemPO pkInfoItem = pkMetadataEntityInfoItems.stream().filter(p -> p.getInfoItemId().equals(relation.getPkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
        MetadataEntityInfoItemPO fkInfoItem = fkMetadataEntityInfoItems.stream().filter(f -> f.getInfoItemId().equals(relation.getFkInfoItemId())).findFirst().orElse(new MetadataEntityInfoItemPO());
        entityRelationsItem = new EntityRelationsItemVO();
        entityRelationsItem.setRelationId(relation.getRelationId());
        entityRelationsItem.setRelationName(relation.getRelationName());
        entityRelationsItem.setPkEntityId(relation.getPkEntityId());
        entityRelationsItem.setPkEntityName((resAndDataEntityDTO1 == null) ? null : resAndDataEntityDTO1.getEntityName());
        entityRelationsItem.setPkInfoItemId(relation.getPkInfoItemId());
        entityRelationsItem.setPkInfoItemName(pkInfoItem.getInfoItemName());
        entityRelationsItem.setFkEntityId(relation.getFkEntityId());
        entityRelationsItem.setFkEntityName((resAndDataEntityDTO2 == null) ? null : resAndDataEntityDTO2.getEntityName());
        entityRelationsItem.setFkInfoItemId(relation.getFkInfoItemId());
        entityRelationsItem.setFkInfoItemName(fkInfoItem.getInfoItemName());
        itemList.add(entityRelationsItem);
      } 
    } else {
      resultMap.put("relationName", null);
    } 
    resultMap.put("itemList", itemList);
    return ResultEntity.successMessage(resultMap);
  }
  
  private MetadataEntityInfoItemPO getInfoItemFromCache(String tokenId, String platCode, Integer dataCategory, Map<Long, MetadataEntityInfoItemPO> infoItemMap, Long infoItemId) {
    MetadataEntityInfoItemPO infoItem;
    if (infoItemMap.containsKey(infoItemId)) {
      infoItem = infoItemMap.get(infoItemId);
    } else {
      infoItem = MetadataManager.getItemInfoById(infoItemId, tokenId, dataCategory, platCode);
      infoItemMap.put(infoItemId, infoItem);
    } 
    return infoItem;
  }
  
  private MetadataEntityPO getEntityFromCache(Map<Long, MetadataEntityPO> entityMap, Long entityId, Integer dataResourceCategory, String platCode, String tokenId) {
    ResAndDataEntityDTO resAndDataEntityDTO;
    if (entityMap.containsKey(entityId)) {
      MetadataEntityPO entity = entityMap.get(entityId);
    } else {
      resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(entityId, dataResourceCategory, platCode, tokenId);
      entityMap.put(entityId, resAndDataEntityDTO);
    } 
    return (MetadataEntityPO)resAndDataEntityDTO;
  }
  
  public ResultEntity<Boolean> updateEntityRelations(UpdateEntityRelationsDTO updateEntityRelationsDTO) {
    MetaEntityRelationsVO relation = this.iResAndDataEntityRelation.getEntityRelationById(updateEntityRelationsDTO.getRelationId(), updateEntityRelationsDTO.getDataResourceCategory(), getDefaultCode());
    if (relation == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_NO_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_NO_EXISTS.getMessage()); 
    if (relation.getRelationName().equals(updateEntityRelationsDTO.getRelationName()) && relation.getFkInfoItemId().equals(updateEntityRelationsDTO.getFkInfoItemId()) && relation.getPkInfoItemId().equals(updateEntityRelationsDTO.getPkInfoItemId()))
      return ResultEntity.successMessage(Boolean.valueOf(true)); 
    if (updateEntityRelationsDTO.getPkInfoItemId() != null && updateEntityRelationsDTO.getPkInfoItemId().equals(updateEntityRelationsDTO.getFkInfoItemId()))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_SAME_CONFIG_ITEM_CANNOT_REFER.getCode()), StatusCodeEnum.DATA_RESOURCE_SAME_CONFIG_ITEM_CANNOT_REFER.getMessage()); 
    MetaEntityRelationsDTO updateRelation = new MetaEntityRelationsDTO();
    updateRelation.setRelationId(relation.getRelationId());
    updateRelation.setRelationName(updateEntityRelationsDTO.getRelationName());
    updateRelation.setFkInfoItemId(updateEntityRelationsDTO.getFkInfoItemId());
    updateRelation.setPkInfoItemId(updateEntityRelationsDTO.getPkInfoItemId());
    updateRelation.setUpdateTime(new Date());
    int updateCount = this.iResAndDataEntityRelation.updateMetadataEntityRelations(updateRelation, updateEntityRelationsDTO.getDataResourceCategory(), getDefaultCode());
    if (updateCount == 0)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_UPDATE_METADATA_ENTITY_RELATION_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_UPDATE_METADATA_ENTITY_RELATION_FAILED
          .getMessage()); 
    MetadataEntityPO pkEntity = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).selectEntityByEntityId(relation.getPkEntityId());
    String dirName = "";
    if (pkEntity != null) {
      MetadataDirectoryPO dir = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).selectDirectoryByDirectoryId(pkEntity.getDirectoryId());
      if (dir != null)
        dirName = dir.getDirectoryName(); 
    } 
    if (dirName != null) {
      String relationName = (updateEntityRelationsDTO.getRelationName() != null) ? updateEntityRelationsDTO.getRelationName() : relation.getRelationName();
      Long oldPKInfoId = relation.getPkInfoItemId();
      Long oldFKInfoId = relation.getFkInfoItemId();
      Long newPKInfoId = updateEntityRelationsDTO.getPkInfoItemId();
      Long newFKInfoId = updateEntityRelationsDTO.getFkInfoItemId();
      String oldRelationName = relation.getRelationName();
      StringBuilder logInfo = new StringBuilder();
      logInfo.append("修改数据关系 ").append("Manage".equals(getDefaultCode()) ? "修改数据资源【" : "修改数据表【").append(dirName).append("】中数据关系【").append(relationName).append("】");
      if (newPKInfoId != null && !newPKInfoId.equals(oldPKInfoId)) {
        MetadataEntityInfoItemPO pkInfo = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(newPKInfoId);
        String pkInfoName = (pkInfo == null) ? "" : pkInfo.getInfoItemName();
        if (oldPKInfoId == null) {
          logInfo.append(",主表字段名称为【" + pkInfoName + "】");
        } else {
          MetadataEntityInfoItemPO oldPkInfo = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(oldPKInfoId);
          String oldPkInfoName = (oldPkInfo == null) ? "" : oldPkInfo.getInfoItemName();
          logInfo.append(",主表字段名称从【").append(oldPkInfoName).append("】修改为【").append(pkInfoName).append("】");
        } 
      } 
      if (newFKInfoId != null && !newFKInfoId.equals(oldFKInfoId)) {
        MetadataEntityInfoItemPO fkInfo = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(newFKInfoId);
        String fkInfoName = (fkInfo == null) ? "" : fkInfo.getInfoItemName();
        if (oldFKInfoId == null) {
          logInfo.append(",子表字段名称为【" + fkInfoName + "】");
        } else {
          MetadataEntityInfoItemPO oldFkInfo = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(oldFKInfoId);
          String oldFkInfoName = (oldFkInfo == null) ? "" : oldFkInfo.getInfoItemName();
          logInfo.append(",子表字段名称从【").append(oldFkInfoName).append("】修改为【").append(fkInfoName).append("】");
        } 
      } 
      if (updateEntityRelationsDTO.getRelationName() != null && !updateEntityRelationsDTO.getRelationName().equals(oldRelationName))
        logInfo.append(",数据关系名称从【").append(oldRelationName).append("】修改为【").append(updateEntityRelationsDTO.getRelationName() + "】"); 
      if (logInfo.length() > 0)
        logSystemInfo(logInfo.toString(), getDefaultCode(), updateEntityRelationsDTO.getTokenId()); 
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  public ResultEntity<UseEntityRelationInfoVO> checkBeforeDelRelation(Long pkEntityId, Long fkEntityId, String tokenId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> allRelations = this.iResAndDataEntityRelation.getAllRelationsByPkAndFkEntityId(pkEntityId, fkEntityId, dataResourceCategory, platCode);
    if (CollectionUtils.isEmpty(allRelations))
      return ResultEntity.errorMessage(Integer.valueOf(-1), "没有找到对应的数据关系"); 
    UseEntityRelationInfoVO useEntityRelationInfoVO = new UseEntityRelationInfoVO();
    UseEntityRelationInfoVO.UseRelationInterfaceInfo useRelationInterfaceInfo = null;
    IMetadataDao collectionMetadataDao = (IMetadataDao)ServiceUtil.getMetadataDao("Collection", IMetadataDao.class);
    List<Map> useRelationInterfaceInfoList = this.iResAndDataEntityRelation.getUseRelationInterfaceInfo(pkEntityId, fkEntityId, dataResourceCategory, getDefaultCode());
    if (!CollectionUtils.isEmpty(useRelationInterfaceInfoList))
      for (Map item : useRelationInterfaceInfoList) {
        useRelationInterfaceInfo = new UseEntityRelationInfoVO.UseRelationInterfaceInfo();
        useRelationInterfaceInfo.setInterfaceId((item.get("interfaceid") != null) ? item.get("interfaceid").toString() : null);
        useRelationInterfaceInfo.setInterfaceName((item.get("interfacename") != null) ? item.get("interfacename").toString() : null);
        useRelationInterfaceInfo.setDirectoryName((item.get("directoryname") != null) ? item.get("directoryname").toString() : null);
        useEntityRelationInfoVO.getUseRelationCollectionInterfaceInfos().add(useRelationInterfaceInfo);
      }  
    ResAndDataEntityDTO resAndDataEntityDTO1 = MetadataManager.selectEntityByEntityId(pkEntityId, dataResourceCategory, platCode, tokenId);
    ResAndDataEntityDTO resAndDataEntityDTO2 = MetadataManager.selectEntityByEntityId(fkEntityId, dataResourceCategory, platCode, tokenId);
    try {
      if (resAndDataEntityDTO1 != null && resAndDataEntityDTO2 != null) {
        ResultEntity<List<GetUseRelationInterfaceInfoVO>> applyResult = this.dataApplyClient.getUseRelationInterfaceInfos(resAndDataEntityDTO1.getDirectoryId(), resAndDataEntityDTO2.getDirectoryId(), tokenId);
        if (applyResult == null)
          return ResultEntity.errorMessage(Integer.valueOf(-1), "获取应用平台应用接口使用情况出错"); 
        if (!CollectionUtils.isEmpty((Collection)applyResult.getObj()))
          for (GetUseRelationInterfaceInfoVO item : applyResult.getObj()) {
            useRelationInterfaceInfo = new UseEntityRelationInfoVO.UseRelationInterfaceInfo();
            useRelationInterfaceInfo.setInterfaceId(item.getApplyId());
            useRelationInterfaceInfo.setInterfaceName(item.getApplyName());
            useRelationInterfaceInfo.setDirectoryName(item.getApplyType());
            useEntityRelationInfoVO.getUseRelationQueryInterfaceInfos().add(useRelationInterfaceInfo);
          }  
      } 
    } catch (Exception e) {
      LogHelper.error("获取应用平台应用接口使用情况出错:", ExceptionUtil.getStackTraceMsg(e));
    } 
    List<Map> excelTemplateInfoList = ((ICollectionToolDao)ServiceUtil.getCollectionToolDao(getDefaultCode(), ICollectionToolDao.class)).getUseRelationExcelTemplateInfo(pkEntityId, fkEntityId);
    if (!CollectionUtils.isEmpty(excelTemplateInfoList)) {
      UseEntityRelationInfoVO.UseRelationTemplateInfo useRelationExcelInfo = null;
      for (Map item : excelTemplateInfoList) {
        useRelationExcelInfo = new UseEntityRelationInfoVO.UseRelationTemplateInfo();
        useRelationExcelInfo.setTemplateId((item.get("templateid") == null) ? null : Long.valueOf(item.get("templateid").toString()));
        useRelationExcelInfo.setTemplateName(String.valueOf(item.get("templatename")));
        useEntityRelationInfoVO.getUseRelationExcelInfos().add(useRelationExcelInfo);
      } 
    } 
    return ResultEntity.successMessage(useEntityRelationInfoVO);
  }
  
  public ResultEntity<Boolean> delEntityRelation(Long relationId, String tokenId, Integer dataResourceCategory) {
    if (relationId == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_ID_NO_EMPTY.getCode()), StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_ID_NO_EMPTY
          .getMessage()); 
    IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class);
    MetaEntityRelationsVO relation = this.iResAndDataEntityRelation.getEntityRelationById(relationId, dataResourceCategory, getDefaultCode());
    if (relation == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_NO_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_REFERENCE_RELATION_NO_EXISTS
          .getMessage()); 
    try {
      int num = this.iResAndDataEntityRelation.deleteMetadataEntityRelationsByRelationId(relationId, dataResourceCategory, getDefaultCode());
      if (num == 0)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DEL_METADATA_ENTITY_RELATION_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_DEL_METADATA_ENTITY_RELATION_FAILED
            .getMessage()); 
      if (relation.getPkEntityId() != null && relation.getFkEntityId() != null) {
        List<MetaEntityRelationsVO> allRelationsList = this.iResAndDataEntityRelation.getAllRelationsByPkAndFkEntityId(relation.getPkEntityId(), relation.getFkEntityId(), dataResourceCategory, getDefaultCode());
        if (CollectionUtils.isEmpty(allRelationsList)) {
          DeleteEntityRelationMsg msg = new DeleteEntityRelationMsg(relation.getPkEntityId(), relation.getFkEntityId(), tokenId, dataResourceCategory);
          RabbitMQUtil.publish("DC.Resource.deleteEntityRelation", msg);
        } 
      } 
    } catch (Exception e) {
      MetadataEntityPO pkEntity = metadataDao.selectEntityByEntityId(relation.getPkEntityId());
      if (pkEntity != null) {
        MetadataDirectoryPO dir = metadataDao.selectDirectoryByDirectoryId(pkEntity.getDirectoryId());
        if (dir != null) {
          String dirName = dir.getDirectoryName();
          logErrorInfo(ExceptionUtil.getStackTraceMsg(e), "级联删除数据关系删除" + ("Manage".equals(getDefaultCode()) ? "数据资源【" : "数据表【") + dirName + "】中数据关系【" + relation
              .getRelationName() + "】失败", getDefaultCode(), tokenId);
        } 
      } 
      return ResultEntity.errorMessage(Integer.valueOf(-1), "删除数据关系失败");
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  private void logErrorInfo(String stackInfo, String msg, String platCode, String tokenId) {
    CommonLogDTO logDTO = new CommonLogDTO();
    logDTO.setPlatCode(platCode);
    logDTO.setTokenId(tokenId);
    logDTO.setStackInformation(stackInfo);
    logDTO.setLoggerInformation(msg);
    logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_ERROR);
    logDTO.setLogType(0);
    logDTO.setModule_code(HeaderInterceptor.getModuleCode());
    RabbitMQUtil.publish("DC.Standard.log", logDTO);
  }
  
  private void logSystemInfo(String msg, String platCode, String tokenId) {
    CommonLogDTO logDTO = new CommonLogDTO();
    logDTO.setPlatCode(platCode);
    logDTO.setTokenId(tokenId);
    logDTO.setLoggerInformation(msg);
    logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_SYSTEM);
    logDTO.setLogType(0);
    logDTO.setModule_code(HeaderInterceptor.getModuleCode());
    RabbitMQUtil.publish("DC.Standard.log", logDTO);
  }
  
  public ResultEntity<Boolean> delEntityRelationGroup(Long pkEntityId, Long fkEntityId, String tokenId, Integer dataResourceCategory, String platCode) {
    if (pkEntityId == null || fkEntityId == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DEL_RELATIONS_ENTITY_ID_NO_EMPTY.getCode()), StatusCodeEnum.DATA_RESOURCE_DEL_RELATIONS_ENTITY_ID_NO_EMPTY
          .getMessage()); 
    List<MetaEntityRelationsVO> allRelationsList = this.iResAndDataEntityRelation.getAllRelationsByPkAndFkEntityId(pkEntityId, fkEntityId, dataResourceCategory, platCode);
    if (CollectionUtils.isEmpty(allRelationsList))
      return ResultEntity.successMessage(Boolean.valueOf(true)); 
    int count = this.iResAndDataEntityRelation.deleteRelationsByPkAndFkEntityId(pkEntityId, fkEntityId, dataResourceCategory, platCode);
    if (count > 0) {
      DeleteEntityRelationMsg msg = new DeleteEntityRelationMsg(pkEntityId, fkEntityId, tokenId, dataResourceCategory);
      RabbitMQUtil.publish("DC.Resource.deleteEntityRelation", msg);
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(pkEntityId, dataResourceCategory, platCode, tokenId);
      if (resAndDataEntityDTO != null) {
        CommonLogDTO logDTO = new CommonLogDTO();
        if ("Manage".equals(getDefaultCode())) {
          logDTO.setLoggerInformation("删除数据关系 删除数据资源【" + resAndDataEntityDTO.getEntityName() + "】中数据关系【" + ((MetaEntityRelationsVO)allRelationsList
              .get(0)).getRelationName() + "】");
        } else {
          logDTO.setLoggerInformation("删除数据关系 删除数据表【" + resAndDataEntityDTO.getEntityName() + "】中数据关系【" + ((MetaEntityRelationsVO)allRelationsList
              .get(0)).getRelationName() + "】");
        } 
        logDTO.setPlatCode(platCode);
        logDTO.setTokenId(tokenId);
        logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_SYSTEM);
        logDTO.setLogType(0);
        logDTO.setModule_code(HeaderInterceptor.getModuleCode());
        RabbitMQUtil.publish("DC.Standard.log", logDTO);
      } 
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  private MetadataEntityView getMetadataEntityView(MetadataEntityPO metadataEntity, Integer dataResourceCategory, String platCode, String tokenId) {
    MetadataEntityView entityView = new MetadataEntityView();
    List<MetadataEntityInfoItemPO> metadataEntityInfoItems = MetadataManager.getEntityInfoItemsByEntityId(metadataEntity.getEntityId(), dataResourceCategory, platCode, tokenId);
    for (MetadataEntityInfoItemPO metadataElement : metadataEntityInfoItems)
      entityView.getMedataElementCol().add(new MetadataElementView(metadataElement)); 
    List<MetaEntityRelationsVO> childRelations = this.iResAndDataEntityRelation.getChildRelationsByEntityId(metadataEntity.getEntityId(), dataResourceCategory, platCode);
    for (MetaEntityRelationsVO relation : childRelations) {
      MetadataEntityRelationsView relationsView = new MetadataEntityRelationsView(relation);
      if (entityView.getChildRelations().stream().anyMatch(v -> (v.getPkEntityId().equals(relationsView.getPkEntityId()) && v.getFkEntityId().equals(relationsView.getFkEntityId()))))
        continue; 
      entityView.getChildRelations().add(relationsView);
    } 
    entityView.setEntityId(metadataEntity.getEntityId());
    entityView.setEntityName(metadataEntity.getEntityName());
    return entityView;
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByPkEntityId(Long pkEntityId, String tokenId, Integer dataResourceCategory, String platCode) {
    IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class);
    List<MetaEntityRelationsVO> childRelations = this.iResAndDataEntityRelation.getChildRelationsByEntityId(pkEntityId, dataResourceCategory, platCode);
    List<MetadataEntityRelationsVO> metadataEntityRelationsListVO = new ArrayList<>();
    for (MetaEntityRelationsVO metadataEntityRelationsPO : childRelations) {
      MetadataEntityRelationsVO metadataEntityRelationsVO = new MetadataEntityRelationsVO();
      BeanUtils.copyProperties(metadataEntityRelationsPO, metadataEntityRelationsVO);
      metadataEntityRelationsListVO.add(metadataEntityRelationsVO);
    } 
    return ResultEntity.successMessage(metadataEntityRelationsListVO);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByFkEntityId(Long fkEntityId, String tokenId, Integer dataResourceCategory, String platCode) {
    IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class);
    List<MetaEntityRelationsVO> parentRelations = this.iResAndDataEntityRelation.getRelationsByFkEntityId(fkEntityId, dataResourceCategory, platCode);
    List<MetadataEntityRelationsVO> metadataEntityRelationsListVO = new ArrayList<>();
    for (MetaEntityRelationsVO metadataEntityRelationsPO : parentRelations) {
      MetadataEntityRelationsVO metadataEntityRelationsVO = new MetadataEntityRelationsVO();
      BeanUtils.copyProperties(metadataEntityRelationsPO, metadataEntityRelationsVO);
      metadataEntityRelationsListVO.add(metadataEntityRelationsVO);
    } 
    return ResultEntity.successMessage(metadataEntityRelationsListVO);
  }
  
  public ResultEntity<List<MetadataEntityViewVO>> getRelationsByDirectoryId(Long directoryId, String tokenId) {
    return ResultEntity.successMessage(null);
  }
  
  public ResultEntity<List<MetadataDataItemUsageVO>> getDataItemUsageDetail(GetDataItemUsageDTO getDataItemUsageDTO, String platCode, String tokenId) {
    if (getDataItemUsageDTO == null || getDataItemUsageDTO.getDataItemId() == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DATA_ITEM_ID_EMPTY.getCode()), StatusCodeEnum.DATA_RESOURCE_DATA_ITEM_ID_EMPTY
          .getMessage()); 
    if (!"Collection".equals(platCode) && !"Manage".equals(platCode))
      return ResultEntity.successMessage(new ArrayList()); 
    Map<String, Object> param = new HashMap<>();
    boolean isEscapeStr = false;
    if (this.dbType.equalsIgnoreCase("sqlserver"))
      isEscapeStr = true; 
    String whereSql = (String)this.query.getWhereSqlStr((QueryModelDTO)getDataItemUsageDTO, this.dbType, true, isEscapeStr).getObj();
    if (!StringUtil.isEmpty(whereSql) && getDataItemUsageDTO.getFilterModel() != null)
      whereSql = " and " + whereSql; 
    param.put("whereSql", whereSql);
    param.put("dataItemId", getDataItemUsageDTO.getDataItemId());
    Map<String, String> paramData = new HashMap<>();
    paramData.put("whereSql", whereSql);
    paramData.put("dataItemId", getDataItemUsageDTO.getDataItemId().toString());
    List<DataItemUsedVO> dataItemUsedVOList = (List<DataItemUsedVO>)this.dataStandardClient.getFieldsByDataItemId(paramData, platCode, tokenId).getObj();
    List<MetadataDataItemUsageVO> usagesVOList = new ArrayList<>();
    if (!CollectionUtils.isEmpty(dataItemUsedVOList))
      for (DataItemUsedVO po : dataItemUsedVOList) {
        MetadataDataItemUsageVO vo = new MetadataDataItemUsageVO();
        BeanUtils.copyProperties(po, vo);
        ResAndDataDirectoryDTO dir = MetadataManager.selectDirectoryByDirectoryId(Long.valueOf(Long.parseLong(vo.getDirectoryId())), platCode, vo.getDataCategory());
        if (dir != null) {
          ResAndDataDirectoryDTO parentDir = MetadataManager.selectDirectoryByDirectoryId(dir.getParentDirectoryId(), platCode, vo.getDataCategory());
          if (parentDir != null)
            vo.setParentDirectoryName(parentDir.getDirectoryName()); 
        } 
        vo.setTableType(Integer.valueOf(0));
        usagesVOList.add(vo);
      }  
    List<MetadataDataItemUsagePO> fileTableUsagesPOList = ((IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(getDefaultCode(), IFileInfoTableDao.class)).getDataItemUsageList(param);
    if (!CollectionUtils.isEmpty(fileTableUsagesPOList))
      for (MetadataDataItemUsagePO po : fileTableUsagesPOList) {
        MetadataDataItemUsageVO vo = new MetadataDataItemUsageVO();
        BeanUtils.copyProperties(po, vo);
        vo.setTableType(Integer.valueOf(1));
        usagesVOList.add(vo);
      }  
    return ResultEntity.successMessage(usagesVOList);
  }
  
  public ResultEntity<List<String>> getParentDirectoryIds(Long directoryId, Integer dataResourceCategory, String platCode) {
    if (!"Collection".equals(platCode) && !"Manage".equals(platCode))
      return ResultEntity.successMessage(new ArrayList()); 
    List<String> list = MetadataManager.getParentDirectoryIds(directoryId, dataResourceCategory, platCode);
    return ResultEntity.successMessage(list);
  }
  
  public boolean relationValid(MetadataEntityRelationsPO relation) {
    if (relation == null)
      return false; 
    if (relation.getPkEntityId() == null || relation.getFkEntityId() == null || relation.getPkEntityId() == null)
      return false; 
    if (relation.getPkInfoItemId() == null || relation.getRelationId() == null)
      return false; 
    return true;
  }
  
  public ResultEntity<List<EntityChildRelationsItemVO>> getChildEntityRelationsByDirectoryId(Long directoryId, String tokenId, Integer dataResourceCategory, String platCode) {
    try {
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectIsMasterMetadataEntityByDirectoryId(directoryId, dataResourceCategory, platCode, tokenId);
      if (null == resAndDataEntityDTO)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_GET_METADATA_ENTITY_BY_DIRECTOY_ID_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_GET_METADATA_ENTITY_BY_DIRECTOY_ID_FAILED
            .getMessage()); 
      Map<Long, MetadataEntityPO> metadataEntityMap = new HashMap<>();
      Map<Long, MetadataEntityInfoItemPO> infoItemMap = new HashMap<>();
      Long entityId = resAndDataEntityDTO.getEntityId();
      List<EntityChildRelationsItemVO> entityChildRelationsItems = getEntityChildRelationsByPkEntityId(entityId, metadataEntityMap, infoItemMap, dataResourceCategory, platCode, tokenId);
      return ResultEntity.successMessage(entityChildRelationsItems);
    } catch (Exception e) {
      LogHelper.error("根据目录id获取当前表的子表关系信息异常:", ExceptionUtil.getStackTraceMsg(e));
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_GET_CHILD_RELATIONS_FAILED.getCode()), StatusCodeEnum.DATA_RESOURCE_GET_CHILD_RELATIONS_FAILED
          .getMessage());
    } 
  }
  
  public List<EntityChildRelationsItemVO> getEntityChildRelationsByPkEntityId(Long entityId, Map<Long, MetadataEntityPO> metadataEntityMap, Map<Long, MetadataEntityInfoItemPO> infoItemMap, Integer dataResourceCategory, String platCode, String tokenId) {
    IMetadataDao metadataDao = (IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class);
    List<EntityChildRelationsItemVO> entityRelations = new ArrayList<>();
    List<MetaEntityRelationsVO> currentRelations = this.iResAndDataEntityRelation.getChildRelationsByEntityId(entityId, dataResourceCategory, platCode);
    for (MetaEntityRelationsVO relationItem : currentRelations) {
      EntityChildRelationsItemVO currentRelation = new EntityChildRelationsItemVO();
      currentRelation.setRelationId(relationItem.getRelationId());
      currentRelation.setRelationName(relationItem.getRelationName());
      Long pkEntityId = relationItem.getPkEntityId();
      MetadataEntityPO pkMetadataEntity = getEntityFromCache(metadataEntityMap, pkEntityId, dataResourceCategory, platCode, tokenId);
      if (null == pkMetadataEntity)
        continue; 
      currentRelation.setPkEntityId(pkEntityId);
      currentRelation.setPkEntityName(pkMetadataEntity.getEntityName());
      currentRelation.setPkDirectoryId(pkMetadataEntity.getDirectoryId());
      Long pkInfoItemId = relationItem.getPkInfoItemId();
      MetadataEntityInfoItemPO pkMetadataInfoItem = getInfoItemFromCache(tokenId, platCode, dataResourceCategory, infoItemMap, pkInfoItemId);
      if (null == pkMetadataInfoItem)
        continue; 
      currentRelation.setPkInfoItemId(pkInfoItemId);
      currentRelation.setPkInfoItemName(pkMetadataInfoItem.getInfoItemName());
      currentRelation.setPkDataItemName(pkMetadataInfoItem.getDataItemName());
      Long fkEntityId = relationItem.getFkEntityId();
      MetadataEntityPO fkMetadataEntity = getEntityFromCache(metadataEntityMap, fkEntityId, dataResourceCategory, platCode, tokenId);
      if (null == fkMetadataEntity)
        continue; 
      currentRelation.setFkEntityId(fkEntityId);
      currentRelation.setFkEntityName(fkMetadataEntity.getEntityName());
      currentRelation.setFkDirectoryId(fkMetadataEntity.getDirectoryId());
      Long fkInfoItemId = relationItem.getFkInfoItemId();
      MetadataEntityInfoItemPO fkMetadataInfoItem = getInfoItemFromCache(tokenId, platCode, dataResourceCategory, infoItemMap, fkInfoItemId);
      if (null == fkMetadataInfoItem)
        continue; 
      currentRelation.setFkInfoItemId(fkInfoItemId);
      currentRelation.setFkInfoItemName(fkMetadataInfoItem.getInfoItemName());
      currentRelation.setFkDataItemName(fkMetadataInfoItem.getDataItemName());
      List<EntityChildRelationsItemVO> childRelations = getEntityChildRelationsByPkEntityId(fkEntityId, metadataEntityMap, infoItemMap, dataResourceCategory, platCode, tokenId);
      currentRelation.setChildRelations(childRelations);
      entityRelations.add(currentRelation);
    } 
    return entityRelations;
  }
  
  public ResultEntity<List<DataRangeUsageVO>> getDataRangeUsageDetail(GetDataRangeUsageDTO usageDTO, String platCode, String tokenId) {
    List<DataRangeUsageVO> usagesVOList = new ArrayList<>();
    List<DataRangeUsagePO> usagesPOList = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getDataRangeUsageList(usageDTO.getCodeTableId());
    if (!CollectionUtils.isEmpty(usagesPOList))
      for (DataRangeUsagePO po : usagesPOList) {
        DataRangeUsageVO vo = new DataRangeUsageVO();
        vo.setTableType(Integer.valueOf(0));
        vo.setPlatCode(platCode);
        BeanUtils.copyProperties(po, vo);
        usagesVOList.add(vo);
      }  
    List<DataRangeUsagePO> fileTableUsagesPOList = ((IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(getDefaultCode(), IFileInfoTableDao.class)).getDataRangeUsageList(usageDTO.getCodeTableId());
    if (!CollectionUtils.isEmpty(fileTableUsagesPOList))
      for (DataRangeUsagePO po : fileTableUsagesPOList) {
        DataRangeUsageVO vo = new DataRangeUsageVO();
        vo.setTableType(Integer.valueOf(1));
        vo.setPlatCode(platCode);
        BeanUtils.copyProperties(po, vo);
        usagesVOList.add(vo);
      }  
    return ResultEntity.successMessage(usagesVOList);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getChildRelationsByEntityId(Long pkEntityId, Integer dataResourceCategory) {
    List<MetadataEntityRelationsVO> metadataEntityRelationsVOList = new ArrayList<>();
    List<MetaEntityRelationsVO> metadataEntityRelationsList = this.iResAndDataEntityRelation.getChildRelationsByEntityId(pkEntityId, dataResourceCategory, getDefaultCode());
    if (!CollectionUtils.isEmpty(metadataEntityRelationsList))
      for (MetaEntityRelationsVO metadataEntityRelationsPO : metadataEntityRelationsList) {
        MetadataEntityRelationsVO metadataEntityRelationsVO = new MetadataEntityRelationsVO();
        BeanUtils.copyProperties(metadataEntityRelationsPO, metadataEntityRelationsVO);
        metadataEntityRelationsVOList.add(metadataEntityRelationsVO);
      }  
    return ResultEntity.successMessage(metadataEntityRelationsVOList);
  }
}
